""" Support for mounting a filestorage. 
    Code derived from the original OFS/MountedItem.py which has now disappeared
    from the CVS.

    Use at your own risk. There's probably gods only know special badness 
    awaiting users of this. 
"""



import os, string, time
import OFS, Globals
from Globals import HTMLFile
from ZODB.Mount import MountPoint
from ZODB.FileStorage import FileStorage
from ZODB.DB import DB

manage_addMountedFileStorageForm=HTMLFile('addMountedFileStorage',globals())

def manage_addMountedFileStorage(self, path="/", id=None, file=None, REQUEST=None):
    """ add a mountpoint """
    mi = MountedFileStorage(path, id, file)
    self._setObject(mi.id, mi)
    if REQUEST is not None:
	return self.manage_main(self, REQUEST)

class MountedFileStorage(MountPoint, OFS.SimpleItem.Item):
    '''A MountPoint with a basic interface for displaying the
    reason the database did not connect.
    '''

    icon = 'p_/broken'
    manage_options = ({'label':'Traceback', 'action':'manage_traceback'},)
    meta_type = 'Mounted FileStorage'
    
    def __init__(self, path, _id=None, file=None):
	if '/' in file:
	    raise "Illegal character '/' in file name"

	file = os.path.join(Globals.INSTANCE_HOME, 'var', file)
	if not os.path.exists(file):
	    raise "Couldn't find file `%s'"%file

        pathItems = string.split(path, '/')
	if not _id:
	    self.id = pathItems[-1]
	else:
	    if pathItems and pathItems[-1]:
		raise "Both path and id specified (choose one)"
	    self.id = _id
        path = string.join(pathItems, '/')

        MountPoint.__init__(self, path, file)
	
	self._params = file

    manage_traceback = HTMLFile('mountfail', globals())

    def mount_error_(self):
        return self._v_connect_error

    def _createDB(self):
	""" Gets the database object, usually by creating a Storage object
        and returning ZODB.DB(storage).
        """
	fs = FileStorage(self._params)
	return DB(fs)

